//arena.cpp implementation

#include <libps.h>
#include <stdio.h>
#include <stdlib.h>
#include "comconst.h"
#include "arena.h"
#include "worm.h"
#include "sound.h"

#define SPEEDINGUP 1000

BOOL CArena::mWormIn[MAXWORMS];
CWorm* CArena::mWorms[MAXWORMS];
BOOL CArena::mWormLeft[MAXWORMS];

#define MAXSOUND 2000
#define MINSOUND 400

CArena::CArena()
{
	for (int g=0; g<MAXWORMS; g++)
	{
		mWormIn[g]=FALSE;
		mWormLeft[g]=FALSE;
	}
	mSoundCount=0;
	mNextSound=((rand()*(MAXSOUND-MINSOUND))/RAND_MAX)+MINSOUND;
}

CArena::~CArena()
{
}

void CArena::Start()
{
	mWormsLeft=0;
	mWormsIn=0;
	for (int g=0; g<MAXWORMS; g++)
	{	
		if (mWormIn[g])
		{
			mWormLeft[g]=TRUE;
			mWormsLeft++;
			mWormsIn++;
		}
		else
		{
			mWormLeft[g]=FALSE;
		}
	}
	mTimeCount=0;
	mJumpCount=0;
	mSpeed=0;
	CWorm::mSpeed=ONE/2;
}

void CArena::AddWorm(int wormno, int colour)
{
}

void CArena::RemoveWorm(int wormno)
{
}


BOOL CArena::AtLeastOneWormIn()
{
	for (int g=0; g<MAXWORMS; g++)
	{	
		if (mWormIn[g])
		{
			return TRUE;
		}
	}
	return FALSE;	
}

int CArena::Timeslice(GsOT* orderingTable)
{	
	for (int g=0; g<MAXWORMS; g++)
	{
		int running;
		
		if (mWormLeft[g])
		{
			mWorms[g]->Respond();
			running=mWorms[g]->Move(orderingTable);
			//mJumpCount++;
			/*if (running && (mJumpCount>10-(mSpeed*2)))
			{	
				mWorms[g]->Respond();
				running=mWorms[g]->Move(orderingTable);
				mJumpCount=0;
			}*/
			if (!running)
			{
				mWormLeft[g]=FALSE;
				mWormsLeft--;
				for (int h=0; h<MAXWORMS; h++)
				{	
					if (mWormLeft[h])
					{
						mWorms[h]->IncScore();
						if (mWorms[h]->GetScore()>=(mWormsIn-1)*10)
						{
							CSound::WinnerSound();
							return 2;
						}	
					}
				}
				CSound::DieSound();
				if (mWormsLeft<2)
				{
					CSound::ResetSpeed();
					return 0;
				}
			}
		}
	}
	mTimeCount++;
	if (mTimeCount>SPEEDINGUP)
	{
		/*if (mSpeed<MAXSPEED)
		{
			CSound::SpeedingSound();
			mSpeed++;
		}*/
		if (CWorm::mSpeed<ONE)
		{
			CWorm::mSpeed+=ONE/10;
			CSound::SpeedingSound();
			CSound::SpeedUp();
		}
		mTimeCount=0;
	}
	mSoundCount++;
	if (mSoundCount>=mNextSound)
	{
		mNextSound=((rand()*(MAXSOUND-MINSOUND)/RAND_MAX)+MINSOUND);
		mSoundCount=0;
		int wormwithbiggestscore=999;
		int biggestscore=0;
		for (int g=0; g<MAXWORMS; g++)
		{
			if (mWormIn[g])
			{
				if (mWorms[g]->GetScore()>biggestscore)
				{
					wormwithbiggestscore=mWorms[g]->GetColour();
					biggestscore=mWorms[g]->GetScore();
				}
				else
				{
					if (mWorms[g]->GetScore()==biggestscore)
					{
						 wormwithbiggestscore=999;
					}
				}
			}
		}
		if (wormwithbiggestscore<999)
		{
			CSound::AheadSound(wormwithbiggestscore);
		}
	}
	return 1;
}

int CArena::GetWinner()
{
	for (int g=0; g<MAXWORMS; g++)
	{	
		if (mWormLeft[g])
		{
			return g;
		}
	}
	return MAXWORMS;
}