//Setup implementation

#include <libps.h>
#include <string.h>	
#include "comconst.h"
#include "credits.h"
	
#define MAXCONTROLLERS 4
#define CREDITSADDR 0x801c8000

CCredits::CCredits()
{
	GsIMAGE im;
	RECT rect;
	RECT crect;

	GsGetTimInfo((unsigned long*)(CREDITSADDR + 4), &im);
	rect.x=im.px;
	rect.y=im.py;
	rect.h=im.ph;
	rect.w=im.pw;
	LoadImage(&rect, im.pixel);
	crect.x=im.cx;
	crect.y=im.cy;
	crect.h=im.ch;
	crect.w=im.cw;
	LoadImage(&crect, im.clut);
	DrawSync(0);
	int tpage=GetTPage(1, 0, rect.x, rect.y);
	mTitle=new GsSPRITE;
	mTitle->attribute=(unsigned long)1<<24;
	mTitle->tpage=tpage;
	mTitle->cx=im.cx;
	mTitle->cy=im.cy;
	mTitle->r=128;
	mTitle->g=128;
	mTitle->b=128;
	mTitle->u=0;
	mTitle->v=0;
	mTitle->x=((SWIDTH-(256*10/6))/2)-XOFFSET;
	mTitle->y=((SHEIGHT-(256*10/6))/2)-YOFFSET;
	mTitle->w=256;
	mTitle->h=256;
	mTitle->mx=0;
	mTitle->my=0;
	mTitle->scalex=10*ONE/6;
	mTitle->scaley=10*ONE/6;
	mTitle->rotate=0;

}

CCredits::~CCredits()
{
}


int CCredits::Timeslice(GsOT* orderingTable)
{
	GsSortClear(255, 255, 255, orderingTable);
	GsSortSprite(mTitle, orderingTable, 0);
	return 0;
}
		