CFLAGS  = -Wall -EL -O2
LFLAGS  = -Ttext 80100000 -e _start -EL \psx\lib\libps.a --warn-common --warn-constructors -Map mapfile

CC      = \psx2\bin\gcc
LD      = \psx2\bin\ld
PROG    = pune
OBJS    = arena.o main.o newdel.o pad.o credits.o\
		  sound.o pixmap.o score.o setup.o sincos.o worm.o

all: $(PROG)

arena.cpp:	comconst.h arena.h worm.h sound.h

pad.cpp:	comconst.h pad.h

pixmap.cpp:	comconst.h pixmap.h

score.cpp:	comconst.h score.h arena.h worm.h

setup.cpp:	comconst.h setup.h pad.h arena.h worm.h

sound.cpp:	comconst.h sound.h

worm.cpp:	comconst.h pad.h worm.h sincos.h pixmap.h sound.h

sincos.cpp:	comconst.h sincos.h

main.cpp:	comconst.h worm.h pad.h pixmap.h arena.h score.h setup.h sound.h

credits.cpp:	comconst.h credits.h

$(PROG):	$(OBJS) 
	$(LD) $(OBJS) $(LFLAGS) -o $(PROG)

.SUFFIXES: .o .cpp

.cpp.o: 
	@set oldpath=%PATH%
	@set path=\psx2\bin
	@set GCC_EXEC_PREFIX=\psx2\lib\gcc-lib
	$(CC) $(CFLAGS) -c $<
	@set path=%oldpath%

