//Setup implementation

#include <libps.h>
#include <string.h>	
#include "comconst.h"
#include "setup.h"
#include "pad.h"
#include "arena.h"
#include "worm.h"
	
#define NUDGES 5	
#define MAXCONTROLLERS 4
#define NEWPUNEADDR 0x801b0000

int CSetup::mWormX[7]={0, 63, 127, 191, 0, 63, 191};
int CSetup::mWormY[7]={115, 115, 115, 115, 184, 184, 184};
int CSetup::mWormW[7]={63, 64, 64, 64, 63, 64, 64};
int CSetup::mWormH[7]={69, 69, 69, 69, 69, 69, 69};

extern CPad* pad[MAXCONTROLLERS];
	
CSetup::CSetup()
{
	GsIMAGE im;
	RECT rect;
	RECT crect;

	GsGetTimInfo((unsigned long*)(NEWPUNEADDR + 4), &im);
	rect.x=im.px;
	rect.y=im.py;
	rect.h=im.ph;
	rect.w=im.pw;
	LoadImage(&rect, im.pixel);
	crect.x=im.cx;
	crect.y=im.cy;
	crect.h=im.ch;
	crect.w=im.cw;
	LoadImage(&crect, im.clut);
	DrawSync(0);
	int tpage=GetTPage(1, 0, rect.x, rect.y);
	for (int g=0; g<MAXCOLOURS+1; g++)
	{	
		mWorms[g]=new GsSPRITE;
		mWorms[g]->attribute=(unsigned long)1<<24;
		mWorms[g]->tpage=tpage;
		mWorms[g]->cx=im.cx;
		mWorms[g]->cy=im.cy;
		mWorms[g]->r=128;
		mWorms[g]->g=128;
		mWorms[g]->b=128;
		mWorms[g]->u=mWormX[g];
		mWorms[g]->v=mWormY[g];
		mWorms[g]->w=mWormW[g];
		mWorms[g]->h=mWormH[g];
		mWorms[g]->mx=0;
		mWorms[g]->my=0;
		mWorms[g]->scalex=2*ONE;
		mWorms[g]->scaley=2*ONE;
		mWorms[g]->rotate=0;
	}
	mTitle=new GsSPRITE;
	mTitle->attribute=(unsigned long)1<<24;
	mTitle->tpage=tpage;
	mTitle->cx=im.cx;
	mTitle->cy=im.cy;
	mTitle->r=128;
	mTitle->g=128;
	mTitle->b=128;
	mTitle->u=0;
	mTitle->v=0;
	mTitle->x=32-XOFFSET;
	mTitle->y=0-YOFFSET;
	mTitle->w=256;
	mTitle->h=115;
	mTitle->mx=0;
	mTitle->my=0;
	mTitle->scalex=2*ONE;
	mTitle->scaley=2*ONE;
	mTitle->rotate=0;

	for (int g=0; g<MAXCONTROLLERS; g++)
	{
		mControllerColour[g]=MAXCOLOURS;
		mNudge[g]=0;
	}
	for (int i=0; i<MAXCOLOURS+1; i++)
	{	
		mColourUsed[i]=FALSE;
	}
	/*
	FntLoad(960, 256);
	mStream[0]=FntOpen(100, 100, 60, 20, 0, 4);
	mStream[1]=FntOpen(50, 150, 250, 50, 0, 150);
	for (int h=0; h<MAXCONTROLLERS; h++)
	{
		mStream[2+h]=FntOpen(50+(h*60), 210, 50, 20, 0, 40);   
	}
	*/
}

CSetup::~CSetup()
{
}

char* CSetup::GetName(int colour, char *string)
{
	switch (colour)
	{
		case 0:	strcpy(string, "RED");
				break;
		case 1: strcpy(string, "BLUE");
				break;
		case 2: strcpy(string, "GREEN");
				break;
		case 3:	strcpy(string, "CYAN");
				break;
		case 4:	strcpy(string, "YELLOW");
				break;
		case 5:	strcpy(string, "PURPLE");
				break;
		case 6:	strcpy(string, "I'm out");
				break;
	}
	return string;				
}

int CSetup::Timeslice(GsOT* orderingTable)
{
/*	char t[100];
	FntPrint(mStream[0], "PUNE");
	FntPrint(mStream[1], "Coded by Grim\nFrom an original rip off by Dick Nuddy\n");
	FntPrint(mStream[2], "Player 1\n%s",GetName(mControllerColour[0], t)); 
	FntPrint(mStream[3], "Player 2\n%s",GetName(mControllerColour[1], t)); 
	FntPrint(mStream[4], "Player 3\n%s",GetName(mControllerColour[2], t)); 
	FntPrint(mStream[5], "Player 4\n%s",GetName(mControllerColour[3], t)); 
	for (int g=0; g<6; g++)
	{
		FntFlush(mStream[g]);
	}
  */
	GsSortSprite(mTitle, orderingTable, 0);
	for (int g=0; g<MAXCONTROLLERS; g++)
	{
		mWorms[mControllerColour[g]]->x=(64+g*128)-XOFFSET;
		mWorms[mControllerColour[g]]->y=250-YOFFSET;
		GsSortSprite(mWorms[mControllerColour[g]], orderingTable, 0);
	}
	for (int g=0; g<MAXCONTROLLERS; g++)
	{
		if (pad[g]->UpPressed())
		{	
			mNudge[g]++;
			if (mNudge[g] == NUDGES)
			{
				int oldcolour=mControllerColour[g];
				do
				{
					mControllerColour[g]++;
					if (mControllerColour[g]>MAXCOLOURS)
					{
						mControllerColour[g]=0;
					}
				} while (mColourUsed[mControllerColour[g]]==TRUE);
				mNudge[g]=0;
				mColourUsed[oldcolour]=FALSE;
				if (mControllerColour[g]<MAXCOLOURS)
				{
					mColourUsed[mControllerColour[g]]=TRUE;
				}
			}
		}
		if (pad[g]->DownPressed())
		{	
			mNudge[g]++;
			if (mNudge[g]==NUDGES)
			{
				int oldcolour=mControllerColour[g];
				do
				{
					mControllerColour[g]--;
					if (mControllerColour[g]<0)
					{
						mControllerColour[g]=MAXCOLOURS;
					}
				} while (mColourUsed[mControllerColour[g]]==TRUE);
				mNudge[g]=0;
				mColourUsed[oldcolour]=FALSE;
				if (mControllerColour[g]<MAXCOLOURS)
				{
					mColourUsed[mControllerColour[g]]=TRUE;
				}
			}
		}
	}
	for (int g=0; g<MAXCONTROLLERS; g++)
	{
		if ((pad[g]->StartPressed()) && (!pad[g]->SelectPressed()))
		{
			for (int h=0; h<MAXCONTROLLERS; h++)
			{	
				if (mControllerColour[h]<MAXCOLOURS)
				{
					if (CArena::mWormIn[h]==TRUE)
					{
						delete CArena::mWorms[h];
					}
					CArena::mWormIn[h]=TRUE;
					CArena::mWorms[h]=new CWorm(pad[h], mControllerColour[h]);
				}
				else
				{
					if (CArena::mWormIn[h]==TRUE)
					{
						CArena::mWormIn[h]=FALSE;
						delete CArena::mWorms[h];
					}
				}
			}
			return 0;
		}
		if ((pad[g]->SelectPressed()) && (pad[g]->StartPressed()))
		{
			return 2;
		}
	}
	return 1;
}
		